#include <os.h>
#include "utils.h"
#include "output.h"

inline void insert(char* buffer, int position, char ins){
    memmove(buffer + position + 1, buffer + position, strlen(buffer) - position + 1);
    *(buffer + position) = ins;
}

inline void insertstr(char* buffer, int position, char* ins){
    memmove(buffer + position + strlen(ins), buffer + position, strlen(buffer) - position + 1);//move everything including null char!
    memcpy(buffer + position, ins, strlen(ins));
}

inline char delchar(char* buffer, int position){
    char deletedchar = buffer[position-1];
    if(position != strlen(buffer))
        memmove(buffer + position - 1, buffer + position, strlen(buffer) - position + 1);
    else
        *(buffer + position - 1) = '\0';
    return deletedchar;
}

inline void delselection(char* buffer, int startoffset, int endoffset){
    if(buffer[endoffset] != '\0')
        memmove(buffer+startoffset, buffer+endoffset, strlen(buffer) - endoffset + 1);//move everything after selection (including null character)
    else
        buffer[startoffset] = '\0';
}

inline int linelen(const char* line){//returns how many characters until newline or null character
    int len;
    for(len = 0; line[len] != '\n' && line[len] != '\0'; len++);
    return len;
}

int strWidth(const char* str){
    int width = 0;
    int i;
    for(i=0; i < strlen(str) && str[i] != '\n'; i++){
        if(str[i] == '\t')
            width += TAB_WIDTH;
        else
            width++;
    }
    return width;
}

int posStrWidth(const char* str, int pos){
    int width = 0;
    for(;pos >= 0;pos--){
        if(str[pos] == '\t')
            width += TAB_WIDTH;
        else
            width++;
    }
    return width;
}

char* getline(char* buffer, int position, int cursorscreenrow){//returns pointer to first character of screen containing position in row=cursorscreenrow
    char* restorebuff = malloc(strlen(buffer) + 1);
    memcpy(restorebuff, buffer, strlen(buffer) + 1);
    buffer[position] = '\0';
    char* linepointer = strrchr(buffer, '\n');
    while(cursorscreenrow > 0 && linepointer != NULL){
        *linepointer = '\0';
        linepointer = strrchr(buffer, '\n');
        cursorscreenrow--;
    }
    memcpy(buffer, restorebuff, strlen(restorebuff) + 1);
    free(restorebuff);
    if(linepointer == NULL)
        return buffer;
    linepointer++;
    return linepointer;
}
